/*

NameParser
Copyright Ryan "Lord of Water" P. 2002

Usage: use the proc ParseName() as an alternative to a line such as: src.name = input("What is your name?")
Questions and/or suggestions should be emailed to: goblin150@aol.com

ParseName() Args--

PercentUppers: percent of upper-case letters allowed in the name
	Default: 50%
PermitKey: 1 if key is allowed to be the same as name, 0 if not
	Default: 0
LowerLimit: least chars allowed in the name
	Default: 3
UpperLimit: most chars allowed in the name
	Default: 13
SavPath: name of savefile to be used in saving the names.
	Default: "PlayerSaves.sav"

Usage--

mob/Login()
	..()
	ParseName()
	src << "Welcome to [world.name]! Your name is [src.name]."

Return nothing

*/

mob/proc
	ParseGuild(var/PercentUppers = 50 as num,var/PermitKey = 1 as num,var/LowerLimit = 2 as num, var/UpperLimit = 24 as num,SavPath = "GuildNameParseSaves.sav" as text)
		guild = input("What do want the guild to be named?","Guild Name")
		if(length(guild) <= UpperLimit && length(guild) >= LowerLimit && countlowers(guild) >= LowerLimit)
			if(ckey(guild) != ckey(src.key) && PermitKey == 0)
				var/savefile/G = new(SavPath)
				var/list/plist
				var/match = 1
				G["GuildNameParseSaves"] >> plist
				if(guild in plist)
					if(G["GuildNameParseSaves/[guild]"] != src.key) match = 0
				if(match)
					var/limit = round(length(guild)/(1+PercentUppers/100),1)
					if(countuppers(guild) < limit)
						src.name = guild
						var/savefile/S = new(SavPath)
						var/list/nameslist = list()
						if(S["GuildNameParseSaves"] != null) S["GuildNameParseSaves"] >> nameslist
						if(src.name in nameslist)
						else nameslist.Add(src.name)
						S["GuildNameParseSaves/[src.name]"] << src.key
						S["GuildNameParseSaves"] << nameslist
					else
						alert(src,"You have included too many upper case letters in your guild name.","Invalid Name")
						ParseName()
				else
					alert(src,"You cannot have the same guild name as somone else in the game.","Invalid Name")
					ParseName()
			else
				src.powerlevel += 0
		else
			alert(src,"Your guild's name must be more that 1 character and less than 24 characters.  Also, you may need to include lower case letters win your guild name as well.","Invalid Name")
			ParseName()

// From LoW's Text Handling.

proc/countlowers(var/string as text)
	var/number = 0
	var/char = ""
	anchor
	char = copytext(string,1,2)
	if(char == lowertext(char) && isnum(text2num(char)) == 0)
		var/firstchar = ckey(char)
		if(lowertext(char) == firstchar)
			number += 1
		if(uppertext(char) == firstchar)
			number += 1
	string = copytext(string,2,0)
	if(length(string) > 0) goto anchor
	else return number
proc/countuppers(var/string as text)
	var/number = 0
	var/char = ""
	anchor
	char = copytext(string,1,2)
	if(char == uppertext(char) && isnum(text2num(char)) == 0)
		var/firstchar = ckey(char)
		if(lowertext(char) == firstchar)
			number += 1
		if(uppertext(char) == firstchar)
			number += 1
	string = copytext(string,2,0)
	if(length(string) > 0) goto anchor
	else return number