/*

NameParser
Copyright Ryan "Lord of Water" P. 2002

Usage: use the proc ParseName() as an alternative to a line such as: src.name = input("What is your name?")
Questions and/or suggestions should be emailed to: goblin150@aol.com

ParseName() Args--

PercentUppers: percent of upper-case letters allowed in the name
	Default: 50%
PermitKey: 1 if key is allowed to be the same as name, 0 if not
	Default: 0
LowerLimit: least chars allowed in the name
	Default: 3
UpperLimit: most chars allowed in the name
	Default: 13
SavPath: name of savefile to be used in saving the names.
	Default: "PlayerSaves.sav"

Usage--

mob/Login()
	..()
	ParseName()
	src << "Welcome to [world.name]! Your name is [src.name]."

Return nothing

*/

mob/proc
	ParseName(var/PercentUppers = 50 as num,var/PermitKey = 1 as num,var/LowerLimit = 2 as num, var/UpperLimit = 24 as num,SavPath = "PlayerSaves.sav" as text)
		char_name = input("What is your name?  (NOTE:  Use a captial letter for the first letter or your name will turn out with 'the' in front of it...).","Name","[src.key]")
		if(length(char_name) <= UpperLimit && length(char_name) >= LowerLimit && countlowers2(char_name) >= LowerLimit)
			if(ckey(char_name) != ckey(src.key) && PermitKey == 0)
				var/savefile/G = new(SavPath)
				var/list/plist
				var/match = 1
				G["NamesList"] >> plist
				if(char_name in plist)
					if(G["NamesList/[char_name]"] != src.key) match = 0
				if(match)
					var/limit = round(length(char_name)/(1+PercentUppers/100),1)
					if(countuppers2(char_name) < limit)
						src.name = char_name
						var/savefile/S = new(SavPath)
						var/list/nameslist = list()
						if(S["NamesList"] != null) S["NamesList"] >> nameslist
						if(src.name in nameslist)
						else nameslist.Add(src.name)
						S["NamesList/[src.name]"] << src.key
						S["NamesList"] << nameslist
					else
						alert(src,"You have included too many upper case letters in your name.","Invalid Name")
						ParseName()
				else
					alert(src,"You cannot have the same name as somone else in the game.","Invalid Name")
					ParseName()
			else
				src.powerlevel += 0
		else
			alert(src,"Your character's name must be more that 1 character and less than 24 characters.  Also, you may need to include lower case letters win your name as well.","Invalid Name")
			ParseName()

// From LoW's Text Handling.

proc/countlowers2(var/string as text)
	var/number = 0
	var/char = ""
	anchor
	char = copytext(string,1,2)
	if(char == lowertext(char) && isnum(text2num(char)) == 0)
		var/firstchar = ckey(char)
		if(lowertext(char) == firstchar)
			number += 1
		if(uppertext(char) == firstchar)
			number += 1
	string = copytext(string,2,0)
	if(length(string) > 0) goto anchor
	else return number
proc/countuppers2(var/string as text)
	var/number = 0
	var/char = ""
	anchor
	char = copytext(string,1,2)
	if(char == uppertext(char) && isnum(text2num(char)) == 0)
		var/firstchar = ckey(char)
		if(lowertext(char) == firstchar)
			number += 1
		if(uppertext(char) == firstchar)
			number += 1
	string = copytext(string,2,0)
	if(length(string) > 0) goto anchor
	else return number